//+---------------------------------------------------------------+
//|                                BBollinger_Sortie_Chart.mq4    |
//|                                      By GGG_Trading           |  
//|                     http://donneeseconomiques.wordpress.com/  |                                                                  |
//+---------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 LightBlue 
#property indicator_color2 LightSkyBlue 
#property indicator_color3 LightSeaGreen
#property indicator_color4 Pink
#property indicator_color5  Lime
#property indicator_color6 Orange
#property indicator_color7 Lime
#property indicator_color8 Orange
#property indicator_width1 2 
#property indicator_width2 2 
#property indicator_width3 2 
#property indicator_width4 2 
#property indicator_width5 1 
#property indicator_width6 1 
#property indicator_width7 2 
#property indicator_width8 2

//---- indicator parameters
extern int    BBPer     =  20;
extern double BBDev     =  2.0;
extern int    BBShift   =  0;
extern int    BBPrix    =  0;
//iCustom(NULL,0,"BBollinger_Sortie_Chart" BBPer,BBDev,BBShift,BBPrix, x,1);  
extern bool show_MA = true;
extern int  MA_Per = 3;
extern int  MA_Meth   = 0;
//---- buffers
double Moving_bas[];
double Moving_haut[];
double Upper[];
double Lower[];
double Fleche_up[];
double Fleche_down[];
double Fleche_up_2[];
double Fleche_down_2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  // IndicatorBuffers(6);
  string Nom; Nom = "BBollinger_Sortie_chart"; 
  IndicatorShortName(Nom);
    IndicatorDigits(Digits+2);
//-----   
   SetIndexBuffer(0,Moving_bas);
   SetIndexBuffer(1,Moving_haut );

   if( show_MA == false ){
       SetIndexStyle(0,DRAW_NONE);//LINE, STYLE_SOLID, 2);
       SetIndexStyle(1,DRAW_NONE);//LINE,  STYLE_SOLID, 2 );
      }
   else {    
        SetIndexStyle(0,DRAW_LINE, STYLE_SOLID, 2);
        SetIndexStyle(1,DRAW_LINE,  STYLE_SOLID, 2 );
        } 
//-----   
   SetIndexBuffer(2,Upper);
   SetIndexStyle(2,DRAW_LINE, STYLE_SOLID, 2);
//-----   
   SetIndexBuffer(3,Lower);
   SetIndexStyle(3,DRAW_LINE, STYLE_SOLID, 2);
//-----   
   SetIndexBuffer(4, Fleche_up );
   SetIndexStyle(4, DRAW_ARROW);//, STYLE_SOLID,2);
   SetIndexArrow(4,233);
   SetIndexEmptyValue(4,0.0);
   SetIndexLabel(4,"Fleche_up");
//-----   
   SetIndexBuffer(5,Fleche_down);
   SetIndexStyle(5, DRAW_ARROW);//, STYLE_SOLID,2);
   SetIndexArrow(5,234);
   SetIndexEmptyValue(5,0.0);// 
   SetIndexLabel(5,"Fleche_down");
//-----   
   SetIndexBuffer(6, Fleche_up_2 );
   SetIndexStyle(6, DRAW_ARROW);//, STYLE_SOLID,2);
   SetIndexArrow(6,233);
   SetIndexEmptyValue(6,0.0);
   SetIndexLabel(6,"Fleche_up_2");
//-----   
   SetIndexBuffer(7,Fleche_down_2);
   SetIndexStyle(7, DRAW_ARROW);//, STYLE_SOLID,2);
   SetIndexArrow(7,234);
   SetIndexEmptyValue(7,0.0);// 
   SetIndexLabel(7,"Fleche_down_2");
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
//----------------------------------------------------- 
   int i, counted_bars;             int History = 5000;
   counted_bars = IndicatorCounted() ;
   if(counted_bars < 0 ) return(0);
   if(Bars < 500 ) return(0); 
//----------------------------------------------------- 
   if( counted_bars <= 500 )     i = Bars - 50;
   if( counted_bars >  500 )     i = Bars-counted_bars-1;   
   if( i > History )             i = History;      
//------------------------------------------------------- 11 --
   while( i >= 0 )                      
     {
       double atr = iATR(NULL,0 ,500,i);
           
      Upper[i] = iBands(NULL, 0, BBPer,BBDev,BBShift,BBPrix, 1,i);   
      Lower[i] = iBands(NULL, 0, BBPer,BBDev,BBShift,BBPrix, 2,i);   


         Moving_haut[i] =iMA(NULL, 0, MA_Per,0,MA_Meth,2,i); 
         Moving_bas[i]  =iMA(NULL, 0, MA_Per,0,MA_Meth,3,i); 
         
      if( Moving_haut[i+1] > Upper[i+1] &&  Moving_haut[i] < Upper[i])
                       Fleche_down[i] = Moving_haut[i]+ atr; 
      else             Fleche_down[i] = 0.0;
  
    if( Moving_bas[i+1] < Lower[i+1] &&  Moving_bas[i] > Lower[i])
                             Fleche_up[i] = Moving_bas[i] - atr; 
      else                   Fleche_up[i] = 0.0;
  
     //----
     i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+